routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Order;
use Carbon\Carbon;

Route::get('/', 'HomeController@index')->name('home');
Route::get('contact', 'HomeController@contact')->name('contact');
Route::post('contact/info', 'ContactController@sentContact')->name('contact.sent');
Route::get('/clear', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('config:cache');
    Artisan::call('view:clear');
    return "Cleared!";
});
Route::get('/access/karim007/job/start', function() {
    chdir('..');
    exec('php artisan queue:work --tries=2 &');
    return "queue is working background!";
});
Route::get('/access/karim007/live', function() {
    @unlink(storage_path().'/framework/down');
    return "Server in Live mode!";
});
Route::get('/karim007/access/maintain', function() {
    Artisan::call('down');
    return "Server in maintain mode!";
});

Route::get('/shop/{slug}','ShopController@postByShop')->name('shop.posts');
Route::post('/shop/search/area','ShopController@shopByArea')->name('shop.search');


/*map system all route*/
Route::post('location','LocationController@index')->name('getLocation');

Route::get('testing/map','LocationController@maps')->name('google.map');

//driver and shop owner registration

Route::get('rider/info', 'Driver\RegisterController@driverbasic')->name('driver.basic');
Route::get('rider/register', 'Driver\RegisterController@driveradd')->name('add.driver');
Route::post('store/rider', 'Driver\RegisterController@store')->name('store.driver');
Route::get('restaurant/info', 'Author\RegisterController@restaurantbasic')->name('restaurant.basic');
Route::get('restaurant/register', 'Author\RegisterController@restaurantadd')->name('add.restaurant');
Route::post('restaurant/store', 'Author\RegisterController@store')->name('store.restaurant');

//thanks page
Route::get('thanks/', 'HomeController@thanks')->name('registration.thanks');

Route::post('subscriber','SubscriberController@store')->name('subscriber.store');

Auth::routes();
Route::get('login/{facebook}', 'Auth\LoginController@redirectToProvider')->name('login.facebook');
Route::get('login/{facebook}/callback', 'Auth\LoginController@handleProviderCallback');

Route::get('login/{google}', 'Auth\LoginController@redirectToProvider')->name('login.google');
Route::get('login/{google}/callback', 'Auth\LoginController@handleProviderCallback');

//for shop all reviews load
Route::get('reviews/load/{id}', 'Auth\ReviewController@loadReviewPage')->name('load.reviews');

Route::group(['middleware'=>['history','auth']], function () {
    Route::post('favorite/{shop}/add','FavoriteController@add')->name('shop.favorite');
    Route::post('reviews/{post}','Auth\ReviewController@store')->name('review.store');
    Route::post('rating/shop','Auth\RatingsController@addnewrate')->name('rating.store');

    Route::post('/shipping', 'Auth\ShippingAddressController@store')->name('shipping.address.store');
    Route::post('/shipping/edit', 'Auth\ShippingAddressController@edit')->name('shipping.address.edit');

    Route::post('/charge', 'Auth\CartController@store')->name('order.store');//stripe

    Route::post('/paypal', 'Auth\CartController@paypal')->name('paypal.checkout');//paypal
    Route::get('/process', 'Auth\CartController@process')->name('paypal.process');//paypal
    Route::get('/cancel', 'Auth\CartController@cancal')->name('paypal.cancel');//paypal
});

Route::group(['as'=>'admin.','prefix'=>'admin','namespace'=>'Admin','middleware'=>['auth','admin','history']], function ()
{
    Route::get('dashboard','DashboardController@index')->name('dashboard');

    Route::get('settings','SettingsController@index')->name('settings');
    Route::put('profile-update','SettingsController@updateProfile')->name('profile.update');
    Route::put('password-update','SettingsController@updatePassword')->name('password.update');

    Route::get('admin-manage','AdminController@index')->name('admin.manage');
    Route::post('admin-block/{id}','AdminController@block')->name('admin.block');
    Route::post('admin-unblock/{id}','AdminController@unblock')->name('admin.unblock');

    //Location
    Route::get('location/city','LocationController@city')->name('city');
    Route::post('city/add','LocationController@addcity')->name('city.add');
    Route::put('city/update','LocationController@updateCity')->name('city.update');
    Route::delete('city/delete{id}','LocationController@destroyCity')->name('city.destroy');
    Route::get('location/state','LocationController@area')->name('areas');
    Route::post('state/add','LocationController@addarea')->name('area.add');
    Route::put('state/update','LocationController@updateArea')->name('area.update');
    Route::delete('state/delete{id}','LocationController@destroyArea')->name('area.destroy');

    Route::resource('category','CategoryController');
    Route::get('food-item','PostController@index')->name('post');

    Route::get('order-manage','OrderController@index')->name('order.driver.manage');
    Route::get('order-complete','OrderController@ordercomplete')->name('order.complete');
    Route::post('order/transaction','OrderController@transaction')->name('order.transaction');
    Route::get('order/transactions','OrderController@transactionpage')->name('page.transaction');
    //assign driver for order
    Route::post('request/driver','OrderController@requestDriver')->name('request.driver');
    Route::put('order/approve/{id}','OrderController@approveorder')->name('order.approve');


    Route::get('shops-manage','ShopController@index')->name('shop.manage');
    Route::post('shop-block/{id}','ShopController@block')->name('shop.block');
    Route::post('shop-unblock/{id}','ShopController@unblock')->name('shop.unblock');
    Route::get('shops/pending','ShopController@pendingshops')->name('pending.shops');
    Route::post('pending/shops/approve{id}','ShopController@shopapprove')->name('approve.shops');
    Route::delete('pending/shops/cancel{id}','ShopController@shopCancel')->name('cancel.shop');
    Route::get('shops/tax','ShopController@taxRate')->name('shops.tax');
    Route::post('shops/tax/update','ShopController@taxUpdate')->name('shops.tax.update');

    Route::get('driver-manage','DriverController@index')->name('driver.manage');
    Route::post('driver-block/{id}','DriverController@block')->name('driver.block');
    Route::post('driver-unblock/{id}','DriverController@unblock')->name('driver.unblock');
    Route::get('pending/drivers','DriverController@pendingdrivers')->name('pending.drivers');
    Route::put('pending/driver/approve{id}','DriverController@driverApprove')->name('approve.driver');
    Route::delete('pending/driver/cancel{id}','DriverController@driverCancel')->name('cancel.driver');

    //cash out controller
    Route::get('cashout/shop/request','CashoutController@shop')->name('cashout.request.shop');
    Route::get('cashout/driver/request','CashoutController@driver')->name('cashout.request.driver');

    Route::get('blocked/user','UserController@blockeduser')->name('user.blocked');
    Route::post('blocked/user/{id}','UserController@unblockeduser')->name('user.unblocked');


    Route::get('/subscriber','SubscriberController@index')->name('subscriber.index');
    Route::delete('/subscriber/{subscriber}','SubscriberController@destroy')->name('subscriber.destroy');

    Route::post('notification/seen','NotificationController@makeSeenOrder')->name('notification.seen');
    Route::view('notify','layouts.backend.inc.notifyadmin',[
        'orders' => Order::latest('created_at')->where('created_at','>=',Carbon::today())->get()
    ]);

});

Route::group(['as'=>'author.','prefix'=>'author','namespace'=>'Author','middleware'=>['auth','author','history']], function ()
{
    Route::get('dashboard','DashboardController@index')->name('dashboard');

    Route::get('account','AccountController@index')->name('account.info');
    Route::put('cashout/request','AccountController@cashout')->name('cashout.request');

    Route::get('settings','SettingsController@index')->name('settings');
    Route::put('profile-update','SettingsController@updateProfile')->name('profile.update');
    Route::post('password-update','SettingsController@updatePassword')->name('password.update');

    Route::get('shop','ShopController@index')->name('shopinfo');
    Route::put('shop-update','ShopController@updateShop')->name('shop.update');

    Route::resource('post','PostController');
    Route::resource('category','CategoryController');

    Route::get('order-manage','OrderController@index')->name('order.manage');
    Route::put('cooking/ready','OrderController@cookingReady')->name('cooking.ready');
    Route::put('shop/cooking/deliver','OrderController@cookingDeliver')->name('shop.cooking.deliver');
    Route::get('transactions','TransactionController@index')->name('transaction.history');

    Route::post('notification/seen','NotificationController@makeSeenOrder')->name('notification.seen');
    Route::view('notify','layouts.backend.inc.notifyshop',[
        'orders' => Order::latest('created_at')->where('created_at','>=',Carbon::today())->where('is_approved',1)->get()
    ]);

    Route::get('reviews','ReviewController@index')->name('review.index');

});

Route::group(['as'=>'driver.','prefix'=>'driver','namespace'=>'Driver','middleware'=>['auth','driver','history']], function ()
{
    Route::get('profile','DashboardController@index')->name('dashboard');
    Route::post('/profile/update','SettingsController@updateProfile')->name('update.profile');
    Route::post('/password/update','SettingsController@updatePassword')->name('update.password');

app/Http/Controllers/Admin/LocationController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Area;
use App\City;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\ValidationException;

class LocationController extends Controller
{
    public function city(){
        $cities = City::all();
        return view('admin.location.cities',compact('cities'));
    }
    public function addcity(Request $request){

        $this->validate($request,[
                'name' =>'required|string|max:191',
            ]);
        $exists = City::where('name',$request->name)->first();
        if (isset($exists->name)){
            $msg = "<span style='color:red;'> <strong>Already exists!!!</strong></span>";
            return $msg;
        }else{
            $city = new City();
            $city->name = $request->name;
            $city->save();
            $msg = "<span style='color:green;'> <strong>Successfully added!!!</strong></span>";
            return $msg;
        }
    }
    public function updateCity(Request $request){
        //dd($request);
        $this->validate($request,[
                'update_name' =>'required|string|max:191',
                'city_id' =>'required|integer|not_in:0|exists:cities,id',
            ]);
        $city = City::findOrFail($request->city_id);
        //dd($city);
        $exists = City::where('name',$request->update_name)->where('id','!=',$request->city_id)->first();
        if (isset($exists->name)){
            $msg = "<span style='color:red;'> <strong>Already exists!!!</strong></span>";
            return $msg;
        }else{
            $city->name = $request->update_name;
            $city->save();
            $msg = "<span style='color:green;'> <strong>Successfully added!!!</strong></span>";
            return $msg;
        }
    }
    public function destroyCity($id){

            $city = City::findOrFail($id);
            if($city){
                if ($city->areas->count() >0){
                    Toastr::error('City is already use. you cant delete this.','Error');
                    return redirect()->back();
                }else{
                    $city->delete();
                    Toastr::success('City is delete successfully','Success');
                    return redirect()->back();
                }
            }
            return redirect()->back();
    }
    public function area(){
        $areas = Area::all();
        $cities = City::all();
        return view('admin.location.area',compact('areas','cities'));
    }
    public function addarea(Request $request){

        $this->validation($request->all())->validate();
        $exists = Area::where( 'city_id','=',$request->city)->where( 'name','=',$request->name)->get()->first();
        //dd($exists);
        if (isset($exists->name) ){
            $msg = "<span style='color:red;'> <strong>Already exists!!!</strong></span>";
            return $msg;
        }else {
            $area = new Area();
            $area->city_id = $request->city;
            $area->name = $request->name;
            $area->save();
            $msg = "<span style='color:green;'>Success! <strong>Successfully added!!!</strong></span>";
            return $msg;
        }
    }
    public function updateArea(Request $request){

        $this->validate($request, [
           'city'=> 'required|integer|exists:cities,id',
           'update_name'=> 'required|string',
           'area_id'=> 'required|integer|exists:areas,id',
        ]);
        $area = Area::findOrFail($request->area_id);
        $exists = Area::where('city_id',$request->city)->where('name',$request->update_name)
            ->where('id','!=',$request->area_id)->first();
        //dd(isset($exists->name));
        if (isset($exists->name)){
            $msg = "<span style='color:red;'> <strong>Already exists!!!</strong></span>";
            return $msg;
        }else {
            $area->city_id = $request->city;
            $area->name = $request->update_name;
            $area->save();
            $msg = "<span style='color:green;'>Success! <strong>Successfully Updated!!!</strong></span>";
            return $msg;
        }
    }
    public function destroyArea($id){

        $area = Area::findOrFail($id);
        if($area){
            if ($area->shops->count() + $area->drivers->count()>0){
                Toastr::error('State is already use. you cant delete this.','Error');
                return redirect()->back();
            }else{
                $area->delete();
                Toastr::success('State is delete successfully','Success');
                return redirect()->back();
            }
        }
        return redirect()->back();
    }
    protected function validation(array $data){
        return Validator::make($data,[
            'name' => ['required','string','max:191'],
            'city' => ['required','integer','exists:cities,id'],
        ]);
    }
}

app/Http/Controllers/LocationController.php
<?php

namespace App\Http\Controllers;

use App\Shop;
use Illuminate\Http\Request;
use App\Area;
use Illuminate\Support\Facades\Session;
use Torann\GeoIP\Facades\GeoIP;

class LocationController extends Controller
{
    public function index(Request $request){
        //dd($request);
        //$loc = \Location::get('116.58.201.15');
        //dd($loc);
        $location = GeoIP::getLocation();

        //dd($location);
        $country = $location['country'];
        $city = $location['city'];
        $state = $location['state'];
        $state_name= $location['state_name'];
        $postal_code= $location['postal_code'];
        $lat = $location['lat'];
        $lng = $location['lon'];
        //$ip = request()->ip();
        //$data = \Location::get($ip);
        $loc = $state_name.','.$state.','.$city.'-'.$postal_code;
        $locat =array(
            'loc' => $loc,
            'lat' => $lat,
            'long' => $lng,
        );
        return $locat;
    }

    public function maps(){
        $shops = Shop::where('is_approved',1)->where('is_blocked',0)->get();
        if ($shops->count() >7) {
            $shops = Shop::latest(8)->IsApproved()->IsBlocked()->get();
        }
        $areas = Area::all();
        return view('maps',compact('shops','areas'));
    }
}

resources/views/admin/location/area.blade.php
@extends('layouts.backend.app')

@section('title','Category')

@push('css')
    <!-- JQuery DataTable Css -->
    <link href="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/css/dataTables.bootstrap.css') }}" rel="stylesheet">
    <style>

        i#close {
            position:absolute;
            right:-0px;
            top:0px;
            cursor:pointer;
            background: #1f6fb2;
        }
        div#popupContact {
            position:absolute;
            left:60%;
            top:17%;
            margin-left:-202px;
            font-family:'Raleway',sans-serif
        }
        form {
            max-width:300px;
            min-width:250px;
            padding:10px 50px;
            border:2px solid gray;
            border-radius:10px;
            background-color:#fff
        }
        input[type=text] {
            width:82%;
            padding:10px;
            border:1px solid #ccc;
            padding-left:40px;
            font-size:16px;
        }
        #name {

            background-repeat:no-repeat;
            background-position:5px 7px
        }
        #submit {
            text-decoration:none;
            width:82%;
            padding:5px;
            margin-top: 2px;
            text-align:center;
            display:block;
            cursor:pointer;
            border-radius:5px
        }
    </style>
@endpush

@section('content')
    <div class="container-fluid">
        <div class="block-header">
            <a class="btn btn-primary waves-effect" onclick="div_show()">
                <i class="material-icons">add</i>
                <span>Add New State</span>
            </a>
        </div>
        <!-- Exportable Table -->
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            ALL State
                            <span class="badge bg-blue">{{ $areas->count() }}</span>
                        </h2>
                    </div>
                    <div class="body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped table-hover dataTable js-exportable">
                                <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>City</th>
                                    <th>State Name</th>
                                    <th>Total User</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tfoot>
                                <tr>
                                    <th>ID</th>
                                    <th>City</th>
                                    <th>State Name</th>
                                    <th>Total User</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </tfoot>
                                <tbody>
                                @foreach($areas as $key=>$area)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ $area->city->name }}</td>
                                        <td>{{ $area->name }}</td>
                                        <td class="text-center">{{ $area->shops->count() + $area->drivers->count() }}</td>
                                        <td>{{ $area->updated_at }}</td>
                                        <td class="text-center">
                                            <button onclick="update_div_show('{{$area->id}}','{{ $area->name }}')" class="btn btn-info waves-effect">
                                                <i class="material-icons">edit</i>
                                            </button>
                                            <button onclick="deleteState({{ $area->id }})" class="btn btn-danger waves-effect">
                                                <i class="material-icons">delete</i>
                                            </button>
                                            <form id="delete-form-{{ $area->id }}" action="{{ route('admin.area.destroy',$area->id) }}" method="POST" style="display: none;">
                                                @csrf
                                                @method('DELETE')
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Exportable Table -->
    </div>
    <!-- Popup Div Starts Here -->
    <div id="popupContact">
        <!-- Contact Us Form -->
        <form id="form_area" hidden="hidden">
            @csrf
            @method('POST')
            <i id="close" class="material-icons red" onclick="div_hide()">close</i>
            <h2>Add area</h2>
            <hr>
            <p id="error_area"></p>
            <label for="city">City Name</label>
            <select class="form-group" name="city" id="city">
                <option value="0">select</option>
                @foreach($cities as $city)
                    <option value="{{ $city->id }}">{{ $city->name }}</option>
                @endforeach
            </select>
            <label for="name">State Name</label>
            <input id="name" class="form-group @error('name') is-invalid @enderror" name="name" placeholder="Name" type="text">
            @error('name')
            <span class="invalid-feedback" role="alert">
                <strong>{{ $message }}</strong>
            </span>
            @enderror
            <input id="submit" class="form-group" name="submit" type="submit">

        </form>
    </div>
    <!-- Popup Div Ends Here -->

    <!-- Popup Div Starts Here -->
    <div id="popupContact">
        <!-- Contact Us Form -->
        <form id="update_area_form" hidden="hidden">
            @csrf
            @method('PUT')
            <i id="close" class="material-icons red" onclick="update_div_hide()">close</i>
            <h2>Update City</h2>
            <hr>
            <p id="update_error_area"></p>
            <label for="city">City Name</label>
            <select class="form-group" name="city" id="city" required>
                @foreach($cities as $city)
                    <option value="{{ $city->id }}">{{ $city->name }}</option>
                @endforeach
            </select>
            <label for="update_name">State Name</label>
            <input id="update_name" value="" class="form-group @error('update_name') is-invalid @enderror" name="update_name" placeholder="Name" type="text">
            @error('update_name')
            <span class="invalid-feedback" role="alert">
                <strong>{{ $message }}</strong>
            </span>
            @enderror
            <input type="hidden" value="" id="area_id" name="area_id">
            <input id="submit" class="form-group" name="submit" type="submit">

        </form>
    </div>
    <!-- Popup Div Ends Here -->
@endsection

@push('js')
    <!-- Jquery DataTable Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/jquery.dataTables.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/js/dataTables.bootstrap.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/dataTables.buttons.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.flash.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/jszip.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/pdfmake.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/vfs_fonts.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.html5.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.print.min.js') }}"></script>

    <script src="{{ asset('assets/backend/js/pages/tables/jquery-datatable.js') }}"></script>
    <script type="text/javascript">
        //Function To Display Popup
        function div_show() {
            document.getElementById('form_area').style.display = "block";
        }
        //Function to Hide Popup
        function div_hide(){
            document.getElementById('form_area').style.display = "none";
            location.reload(true);
        }
        $(document).ready(function() {

            $("#form_area").submit(function () {
                $("#error_area").html('');
                if ($('#name').val() == '' | $('#city').val() <=0) {
                    var msg = "<span style='color:red;'>Error! <strong>Field Must not be empty!!!</strong></span>";
                    $("#error_area").html(msg);
                } else {
                    //alert("working");
                    $.post("<?php echo url(route('admin.area.add')) ?>", $("#form_area").serialize(), function (data) {
                        //alert("working");
                        $('#name').val('');
                        $("#error_area").html(data);
                    });

                }
                return false;
            });
        });
    </script>
    <script type="text/javascript">
        //Function To Display Popup
        function update_div_show(id, name) {
            //alert(id);
            document.getElementById('update_area_form').style.display = "block";
            $("#area_id").val(id);
            $("#update_name").val(name);
            $("#update_error_area").html('');
        }
        //Function to Hide Popup
        function update_div_hide(){
            document.getElementById('update_area_form').style.display = "none";
            location.reload(true);//for page refresh
        }
        $(document).ready(function() {

            $("#update_area_form").submit(function () {
                $("#update_error_area").html('');
                if ($('#update_name').val() == '') {
                    var msg = "<span style='color:red;'><strong>Field Must not be empty!!!</strong></span>";
                    $("#update_error_area").html(msg);
                } else {
                    //alert("working");
                    $.post("<?php echo url(route('admin.area.update')) ?>", $("#update_area_form").serialize(), function (data) {
                        $("#update_error_area").html(data);
                    });
                }
                return false;
            });
        });
    </script>
    <script src="https://unpkg.com/sweetalert2@7.19.1/dist/sweetalert2.all.js"></script>
    <script type="text/javascript">
        function deleteState(id) {
            swal({
                title: 'Are you sure?',
                text: "You want to delete this State!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!',
                cancelButtonText: 'No, cancel!',
                confirmButtonClass: 'btn btn-success',
                cancelButtonClass: 'btn btn-danger',
                buttonsStyling: false,
                reverseButtons: true
            }).then((result) => {
                if (result.value) {
                    event.preventDefault();
                    document.getElementById('delete-form-'+id).submit();
                } else if (
                    // Read more about handling dismissals
                    result.dismiss === swal.DismissReason.cancel
                ) {
                    swal(
                        'Cancelled',
                        'Cant delete :)',
                        'error'
                    )
                }
            })
        }
    </script>
@endpush